#include <Joystick.h>
Joystick_ Joystick;

unsigned long curTime = 0;
unsigned long oldTime = 1;
volatile int pulseLength = 0;
volatile int channel = 0;

void ISR1()
{
  curTime = micros();
  pulseLength = curTime - oldTime;
  oldTime = curTime;

  if (pulseLength > 3000) {
    channel = 0;
    Joystick.sendState();
  } else {
    channel++;
    setChannel(channel, pulseLength);
  }
}

void setChannel(int ch, int pulse)
{
  // Processing pulses with length 800 - 2200 mks.
  float value = (pulse - 800) / 1400.0;

  if (value < 0)
    value = 0;
  else if (value > 1.0)
    value = 1.0;

  switch (ch) {
    case 1:
      Joystick.setXAxis(value * 1024); //поправку вносить триммерами. использовать поправки кодом нежелательно
      
      break;

    case 2:
      Joystick.setYAxis(value*1024); //поправку вносить триммерами. использовать поправки кодом нежелательно
      
      break;

    case 3:
      Joystick.setThrottle(value*1024-132); //поправка на дроссель. при отжатом до упора вниз стике дросселя значение должно быть 0..10
      // в среднем значение может быть в диапазоне 96..160. идеально если попало в 128
       break;
   
    case 4:
        Joystick.setRxAxis(value*1024);
      
    
      break;

    case 5:
        Joystick.setRzAxis(value*1024);
      break;

    case 6:
        Joystick.setRyAxis(value*1024);
      break;
  }

  //      int test = value*1024-132;
//      if (test>0)Joystick.setButton(0, 1);
//      if (test>10)Joystick.setButton(1, 1);
//      if (test>20)Joystick.setButton(2, 1);
//      if (test<0)Joystick.setButton(0, 0);
//      if (test<10)Joystick.setButton(1, 0);
//      if (test<20)Joystick.setButton(2, 0);
//  
}

void setup()
{
  Joystick.begin(false);
  attachInterrupt(0, ISR1, FALLING);
}

void loop()
{
  delay(10);
}
